library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity portAcoded is
    Port ( 
		inbyte : in std_logic_vector(7 downto 0);
		CS_n : in std_logic;
		WR_n : in std_logic;
		ADDR : in std_logic_vector(1 downto 0);
		coded : out std_logic_vector(2 downto 0)
		);
end portAcoded;

architecture behavioral of portAcoded is

begin

 process (WR_n) is
   begin
	 
	if WR_n = '0' and ADDR = "00" and CS_n = '0' then
			
   	case inbyte is
		when "11111110" => coded <= "000";
		when "11111101" => coded <= "001";
		when "11111011" => coded <= "010";
		when "11110111" => coded <= "011";
		when "11101111" => coded <= "100";
		when "11011111" => coded <= "101";
		when "10111111" => coded <= "110";
		--when "01111111" => coded <= "111";
		when others => coded <= "111";
	   end case;
	
	end if;
		
 end process;
end behavioral;
